/*****************************************************************/
/* Archivo que implementa el algoritmo de ordenamiento HeapSort  */
/*		es llamado con la funcion heapSort().					 */
/*****************************************************************/



/*****************************************************************/
/*   Arreglo[]: arreglo a ordenar.								 */
/*	 heasize[]: tamao del arreglo.	 							 */
/*****************************************************************/
void heapify (long int Arreglo[], int i, int heapsize )
{
	long int derecha, izquierda, mayor;
	long int temp;
	izquierda=2*i+1;
	derecha=2*i+2;

	if (izquierda<=heapsize && Arreglo[izquierda]>Arreglo[i]) mayor=izquierda;
	else mayor=i;
	if (derecha<=heapsize && Arreglo[derecha]>Arreglo[mayor]) mayor=derecha;
	if (mayor != i)
	{
		temp=Arreglo[i];
		Arreglo[i]=Arreglo[mayor];
		Arreglo[mayor]=temp;
		heapify (Arreglo, mayor, heapsize);
	}
}


/*****************************************************************/
/*		Contruccion del heap. Esto se logra aplicando la 		 */
/*		funcion heapify de manera de cubrir el areglo desde 	 */
/*					arriba hacia abajo                           */
/*****************************************************************/
void buildheap (long int Arreglo[], int largo)
{
	int i;
	for (i=(int) ((largo/2)-1);i>=0;i--)
	    heapify(Arreglo, i, largo);
}


/*****************************************************************/
/*                         Algoritmo HeapSort                    */
/*   1 se construye un heap invocando a buildheap.              */
/*   2 se intercambia el primer elemento, la raizy el mayor elemento
        del heap con el ultimo.
/*   3 se restituye la propiedad heapen el heap de n-1 elementos */
/******************************************************************/

void heapSort(long int Arreglo[], int largo)
{
	int i, heapsize;
	long int temp;

	largo=largo-1;
	heapsize=largo;

	buildheap(Arreglo, largo);

	for (i = (int)(largo);i>=1;i--)
	{
		temp=Arreglo[0];
		Arreglo[0]=Arreglo[i];
		Arreglo[i]=temp;
		heapsize=heapsize-1;
		heapify(Arreglo,0,heapsize);
	}
}


