/*******************************************************************/
/*    Particion: encargado de poner los elementos menores o        */
/*              iguales a A[p]en la region inferior del arreglo    */
/*              y los elementos menores o iguales en la otra mitad.*/
/*    A[p]    = debe ser el pivote.                                */
/*******************************************************************/
int partition (int A[], int p, int r)
{
	int x = A[p];
	int i = p-1;
	int j = r+1;
	int temporal;

	while (1)
	{
		while (A[--j] > x);
		while (A[++i] < x);
		if ( i<j )
		{
			temporal = A[i];
			A[i] = A[j];
			A[j] = temporal;
		}
		else
		return j;
	}
}


/*****************************************************************/
/*                     Algoritmo QuickSort                       */
/* 1 el arreglo se particiona en dos sub-arreglos no vacios,    */
/*    tal que cada elemento de un sub-arreglo sea menor o igual  */
/*	  a los elementos del otro sub-arreglo.                      */
/* 2 los dos arreglos son ordenados llamando recursivamente a   */
/*      quicksort.                                               */
/* 3 como cada arreglo ya esta ordenado no se nesecita nada mas.*/
/*****************************************************************/
void quickSort(int A[], int p, int r)
{
	int q;

	if (p < r)
	{
		q=partition(A, p, r);
		quickSort(A, p, q);
		quickSort(A, q+1, r);
	}
}
